# Contributing

## Making Issues
This project can ALWAYS be improved. If you come across any bugs, have any questions or dream up a new feature for Odin then you should [open an issue](https://github.com/theycallmemac/odin/issues/new/choose) to talk about it. This is the easiest way to get involved with the project!

## Building Features
If you want to help build out Odin's capabilities, feel free to join the discussion on any issues. I'd be more than happy to assign new people to issues on the project.

If you do want to contribute by enhancing Odin's feature set, please consult the section below on commits.

#### Format of Commit Messages

The format of all commit messages should correspond to the following format:

```<type>: <message>```

Where `<message>` clearly explains why this change is being made and `<type>` corresponds to one of the following:

- ADD  (used for a new feature)
- FIX  (used for a bug fix)
- REMOVE  (used to delete feature)
- REFACTOR  (used when refactoring code)
- STYLE  (used for lint fixes, formatting, missing semi colons, etc; no code change)
- DOCS  (used for changes to documentation)
- TEST  (used when adding or refactoring tests)
- OTHER  (other, explain in the body)

------------
