![Odin Logo](https://i.imgur.com/cwmb5j4.png)

![Odin Engine](https://github.com/theycallmemac/odin/workflows/Odin%20Engine/badge.svg) ![Odin CLI](https://github.com/theycallmemac/odin/workflows/Odin%20CLI/badge.svg) ![Go Odin SDK](https://github.com/theycallmemac/odin/workflows/Go%20Odin%20SDK/badge.svg) ![Python Odin SDK](https://github.com/theycallmemac/odin/workflows/Python%20Odin%20SDK/badge.svg)

## 📖 Overview

Odin is a programmable, observable and distributed job orchestration system which allows for the scheduling, management and unattended background execution of user created tasks on Linux based systems.

Job schedulers by definition are supposed to eliminate toil, a kind of work tied to running a service which is manual, repetitive and most importantly, automatable. While Odin cares about what is to be executed and when it will be executed, Odin is equally concerned with the expected behaviour of your job, which is described entirely by the user’s code. 

This observability is achieved through a web facing user interface which displays job logs and metrics. All of this is gathered through the use of Odin Libraries written in Go, Node.js and Python.

Odin can infer the internal state of jobs by leveraging these libraries, which in turn can be used to speed up the debugging process associated with jobs which yield unexpected behaviour.


## 🔧 Installation

To install Odin please consult the [installation guide](https://github.com/theycallmemac/odin/blob/master/INSTALL.md) for a quick walkthrough on setting up the system.

## 🚀 Usage

You can check out the documentation for using Odin [here](https://github.com/theycallmemac/odin/blob/master/DOCS.md). 

## 👤 Author

**James McDermott**

- Email: <james.mcdermott7@mail.dcu.ie>
- Twitter: [@theycallmemac_](https://twitter.com/theycallmemac_)
- Github: [@theycallmemac](https://github.com/theycallmemac)

## ⭐️ Show your support

Give a ⭐️ if this project helped you!

## 📝 License

Copyright © 2020 [James McDermott](https://github.com/theycallmemac)<br /> This project is [MIT](https://github.com/theycallmemac/odin/blob/master/LICENSE) licensed.

---

